global Event collideHappened;
global Event moveHappened;
global Event moveHappened2;
global Event moveHappened3;
global Event spaceHappened;
global Event spaceHappened2;
global Event boundHappened;
global Event mel2Collision;
global Event mel2Gone;
global Event pCollision;
global Event pGone;
Gain g4;
SinOsc s => ADSR e => NRev reverb => Gain g => dac;
0.2 => reverb.mix;
global float bpm;
100 => bpm;
bpm / 60 => float bps;
1000 / bps => float mspb;
mspb * 4 => float fourbeats;
SndBuf drumBuf => Gain drumgain => dac;
me.dir() + "send.wav" => drumBuf.read;
0.2 => drumgain.gain;



5::ms => dur POS_RATE;
POS_RATE / ((fourbeats)::ms) => float posInc;

1 => int mel2Play;
0 => int pPlay;

//global variables
//tracking the motion of incoming blocks
global float playheadPos;
global int prefabSelector;

//incoming Unity variables, determine freq of the melody note
global float freqPosition;
global float freqPosition2;
global float pPos;
0 => freqPosition;
0 => freqPosition2;
1 => pPos;

fun void backing() {

    // infinite time-loop
    while( true )
    {
        0 => drumBuf.pos;
        0 => playheadPos;
        bpm / 100 => drumBuf.rate;
        
        bpm / 60 => bps;
        1000 / bps => mspb;
        mspb * 4 => fourbeats;
        POS_RATE / ((fourbeats)::ms) => posInc;
        
        1.5 => g.gain;
        // set A, D, S, and R
        e.set( (fourbeats / 8)::ms, 0::ms, 0.8, ((fourbeats / 8)*3)::ms );
        // (note: A, D, R are durations; S is a number between 0 and 1)

        // set gain
        1.3 => s.gain;
        //set freqs
        32 => Std.mtof => s.freq;
        // choose freq
        // key on: begin ATTACK
        // (note: ATTACK automatically transitions to DECAY;
        //        DECAY automatically transitions to SUSTAIN)
        e.keyOn();
        // advance time by 500 ms
        // (note: this is the duration from the
        //        beginning of ATTACK to the end of SUSTAIN)
        (fourbeats / 2)::ms => now;
        // key off; start RELEASE
        e.keyOff();
        // allow the RELEASE to ramp down to 0
        e.releaseTime() => now;

        // advance time by 300 ms (duration until the next sound)
        (fourbeats / 8)::ms => now;
        bpm + 2 => bpm;
    }
}


//melody instrument
Rhodey voc1 => ADSR env => JCRev r => Gain g2 => dac;
//secondary spawned melody instrument
StifKarp voc2 => ADSR env2 => JCRev r2 => Gain g2n => dac;

.6 => r.gain;
.3 => r.mix;
.5 => r2.gain;
.1 => r2.mix;
fun void melEnv() {
    env.set(0::ms, 0::ms, 0.9, (mspb / 8)::ms );
    while(true) {
        1.0 => voc1.noteOn;
                if (bpm > 142) {
                    Std.mtof(freqPosition + 12) => voc1.freq;
                }
                if (bpm > 180) {
                    Std.mtof(freqPosition + 24) => voc1.freq;
                }
                else {
                    Std.mtof(freqPosition) => voc1.freq;
                }
        env.keyOn();
        ((mspb * 3) / 8)::ms => now;
        env.keyOff();
        ((mspb / 8))::ms => now;
    }
}

fun void melEnv2() {
    env2.set(0::ms, 0::ms, 0.9, (mspb / 8)::ms );
    while(true) {
        for (0 => int i; i < 4; i++) {
            if (mel2Play == 1) {
                1.0 => voc2.noteOn;
                if (bpm > 142) {
                    Std.mtof(freqPosition2 + 12) => voc2.freq;
                }
                if (bpm > 180) {
                    Std.mtof(freqPosition2 + 24) => voc2.freq;
                }
                else {
                    Std.mtof(freqPosition2) => voc2.freq;
                }
                
                env2.keyOn();
                ((mspb * 5) / 8)::ms => now;
                env2.keyOff();
                ((mspb * 3) / 8)::ms => now;
            }
            else {
                1 => mel2Play;
                ((mspb * 8) / 8)::ms => now;
            }
        }
        
    }
}

fun void melEnv2() {
    env2.set(0::ms, 0::ms, 0.9, (mspb / 8)::ms );
    while(true) {
        for (0 => int i; i < 4; i++) {
            if (mel2Play == 1) {
                1.0 => voc2.noteOn;
                Std.mtof(freqPosition2) => voc2.freq;
                env2.keyOn();
                ((mspb * 5) / 8)::ms => now;
                env2.keyOff();
                ((mspb * 3) / 8)::ms => now;
            }
            else {
                1 => mel2Play;
                ((mspb * 8) / 8)::ms => now;
            }
        }
        
    }
}

// our main loop
spork ~ backing();
spork ~ updateBlockMovement();
spork ~ listenForMove();
spork ~ listenForMove2();
spork ~ melEnv();
spork ~ melEnv2();
spork ~ listenForMel2Gone();
spork ~ listenForMel2Collision();
spork ~ listenForCollision();
spork ~ listenForSpace();
spork ~ percussive();
spork ~ percussiveP();
spork ~ listenForPCollision();


fun void updateBlockMovement() {
    while( true )
        {
            // increment
            posInc +=> playheadPos;
            // advance time
            POS_RATE => now;
        }
}



while (true) {
    1::second => now;
}

fun void listenForCollision()
{
    while( true )
    {
        // wait for event
        collideHappened => now;
        spork ~ play();
        100 => bpm;
        0.1::ms;
    }
}


fun void play() {
    SndBuf impactBuf => dac;
    me.dir() + "fail2.wav" => impactBuf.read;
    0.7 => impactBuf.gain;
    // start at the beginning of the clip
    0 => impactBuf.pos;
    bpm / 100 => impactBuf.rate;
    impactBuf.length() / impactBuf.rate() => now;
}

fun void listenForMove() {
    0 => g2.gain; 
    while (true) {
        moveHappened => now;
        1.0 => g2.gain;
    }
}

fun void listenForMove2() {
    0 => g2n.gain; 
    while (true) {
        moveHappened2 => now;
        0.7 => g2n.gain;
    }
}
/**
fun void listenForMove3() {
    0 => g4.gain; 
    while (true) {
        moveHappened3 => now;
        1.0 => g4.gain;
    }
}
*/

fun void listenForSpace() {
    while (true) {
        spaceHappened => now;
    }
}

fun void listenForSpace() {
    while (true) {
        spaceHappened2 => now;
    }
}
fun void percussive() {
    while (true) {
        //recalc bpm
        bpm / 60 => bps;
        1000 / bps => mspb;
        for (0 => int i; i < 4; i++) {
           if (i % 2 == 1) {
               spork ~ playPercussive(bpm);
           }
           (mspb)::ms => now;
        } 
    }  
}

fun void percussiveP() {
    while (true) {
        //recalc bpm
        bpm / 60 => bps;
        1000 / bps => mspb;
        for (0 => int i; i < 4; i++) {
           if (pPlay == 1) {
               spork ~ playPercussive2();
               0 => pPlay;
           }
           (mspb)::ms => now;
        } 
    }  
}

fun void playPercussive(float beats) {
    SndBuf kickBuf => dac;
    me.dir() + "Boom-Kick.wav" => kickBuf.read;
    0.6 => kickBuf.gain;
    // start at the beginning of the clip
    0 => kickBuf.pos;
    beats / 100 => kickBuf.rate;
    kickBuf.length() / kickBuf.rate() => now;    
}

fun void playPercussive2() {
    SndBuf kickBuf => dac;
    me.dir() + "Electronic-Kick-3.wav" => kickBuf.read;
    1.5 => kickBuf.gain;
    // start at the beginning of the clip
    0 => kickBuf.pos;
    pPos => kickBuf.rate;
    kickBuf.length() / kickBuf.rate() => now;    
}

fun void listenForBound() {
   while (true) {
      boundHappened => now;
   } 
}

fun void listenForMel2Gone() {
    while (true) {
        mel2Gone => now;
        0 => g2n.gain;
    }
}

fun void listenForMel2Collision() {
    while (true) {
        mel2Collision => now;
        0 => mel2Play;
    }
}

fun void listenForPCollision() {
    while (true) {
        pCollision => now;
        1 => pPlay;
    }
}
/**
fun void listenForPGone() {
    while (true) {
        pGone => now;
        0 => g4.gain;
    }
}
*/


